﻿Type.registerNamespace('RssWebPart');

RssWebPart.CustomPageComponent = function (webPartPageComponentId) {
    this._webPartPageComponentId = webPartPageComponentId;
    RssWebPart.CustomPageComponent.initializeBase(this);
}
RssWebPart.CustomPageComponent.prototype = {
    init: function () { },
    getFocusedCommands: function () {

        return ['RssWebPart.SaveCommand',
            'RssWebPart.URLQueryCommand',
            'RssWebPart.URLCommand',
            'RssWebPart.ContextualGroupCommand',
            'RssWebPart.TabCommand', 
            'RssWebPart.GroupCommand'];
    },
    getGlobalCommands: function () {
        return [];
    },
    
    canHandleCommand: function (commandId) {
        var cmds = this.getFocusedCommands();
        for (var i = 0; i < cmds.length; i++) {
            if (cmds[i] == commandId) {
                return true;
            }
        }
        return false;
    },
    handleCommand: function (commandId, properties, sequence) {
        if (commandId === 'RssWebPart.URLQueryCommand') {
            properties['Value'] = $('#' + this.getId() + ' input:first').val();
            return true;
        }
        if (commandId === 'RssWebPart.SaveCommand') {
            SP.UI.Notify.addNotification('<img src="/_layouts/images/loadingcirclests16.gif"/> Saving Web Part...');
            $('#' + this.getId() + ' input:first').val($('#WebPartsInAction\\.RssContextualTab\\.Feed\\.URL').val());
            __doPostBack($('#' + this.getId() + ' div:first > div:first')[0].id, '');            
            return true;
        }
    },
    getId: function () {
        return this._webPartPageComponentId;
    },
    isFocusable: function () {
        return true;
    }
}
RssWebPart.CustomPageComponent.registerClass('RssWebPart.CustomPageComponent', CUI.Page.PageComponent);

function pageComponentFactory(webPartPageComponentId, componentClass, jsFile, jsFilePath) {
    this.webPartPageComponentId = webPartPageComponentId;
    this.pageComponent = null;
    this.jsFile = jsFile;
    this.jsFilePath = jsFilePath;
    this.componentClass = componentClass;
    this.add = function () {
        if (typeof SP.Ribbon.PageManager.get_instance().getPageComponentById(webPartPageComponentId) == 'undefined') {
            pageComponent = new RssWebPart.CustomPageComponent(webPartPageComponentId);        
            SP.Ribbon.PageManager.get_instance().addPageComponent(pageComponent);
        }
    }
}
pageComponentFactory.prototype = {
    register: function () {
        SP.SOD.registerSod(this.jsFile, this.jsFilePath);
        SP.SOD.executeFunc(this.jsFile, this.componentClass, this.add);
    }
}

function createRssRibbon(webPartPageComponentId) {
    return new pageComponentFactory(webPartPageComponentId, 'RssWebPart.CustomPageComponent', 'rssribbon.js', '/_layouts/rssribbon.js');
}




SP.SOD.notifyScriptLoadedAndExecuteWaitingJobs("RssRibbon.js");

