﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Administration;
using System.Runtime.InteropServices;
using System.Xml.Linq;
using System.Xml.XPath;
using Microsoft.SharePoint.WebPartPages;
using System.IO;
using System.Xml;
using Microsoft.SharePoint.Utilities;

namespace WebPartsInAction.Ch12.Mobility {
    [Guid("C721BF4D-F892-45B2-A098-B9610F85A2FD")]
    public class BrowserDefinitionTimerJob : SPJobDefinition {
        public BrowserDefinitionTimerJob()
            : base() {

        }

        public BrowserDefinitionTimerJob(string name, SPWebApplication webApplication) :
            base(name, webApplication, null, SPJobLockType.None) {

        }

        public override string DisplayName {
            get {
                return "Add custom browser definition file";
            }
        }

        public override string Description {
            get {
                return "Copies a custom browser definition file to the App_Browsers directory";
            }
        }

        public override void Execute(Guid targetInstanceId) {

            bool add = (bool)this.Properties["add"];

            foreach (SPUrlZone zone in Enum.GetValues(typeof(SPUrlZone))) {
                if (this.WebApplication.IisSettings.Keys.Contains(zone)) {
                    string path = this.WebApplication.IisSettings[zone].Path + @"\App_Browsers\customAdapters.browser";

                    if (add) {
                        if (!File.Exists(path)) {
                            string sourcePath = SPUtility.GetGenericSetupPath(@"TEMPLATE\FEATURES\WebPartsInAction.Ch12.Mobility_MobileAdapter\Browser\customAdapters.browser");
                            File.Copy(sourcePath, path);

                            string compatPath = this.WebApplication.IisSettings[zone].Path + @"\App_Browsers\compat.browser";
                            File.SetLastWriteTime(compatPath, DateTime.Now);


                        }
                    }
                    else {
                        if (File.Exists(path)) {
                            File.Delete(path);
                        }
                    }

                }

            }
        }
    }
}
