﻿using WebPartsInAction.Ch13.MVPWebPart.SiteListsWebPart;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Linq;

namespace WebPartsInAction.Ch13.MVPWebPart.Test
{
    
    
    /// <summary>
    ///This is a test class for ListsPresenterTest and is intended
    ///to contain all ListsPresenterTest Unit Tests
    ///</summary>
    [TestClass()]
    public class ListsPresenterTest {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext {
            get {
                return testContextInstance;
            }
            set {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for ListsPresenter Constructor
        ///</summary>
        [TestMethod()]
        public void ListsPresenterConstructorTest() {

            IListsView view = new MockView();
            IListsService model = new MockModel();
            ListsPresenter target = new ListsPresenter(view, model);
            Assert.IsNotNull(target); 
        }

        /// <summary>
        ///A test for ListsPresenter Constructor
        ///</summary>
        [TestMethod()]
        public void ListsPresenterConstructorTest1() {
            IListsView view = new MockView();
            ListsPresenter target = new ListsPresenter(view);
            Assert.IsNotNull(target); 
        }

        /// <summary>
        ///A test for LoadLists
        ///</summary>
        [TestMethod()]
        public void LoadListsTest() {
            IListsView view = new MockView();
            IListsService model = new MockModel();
            ListsPresenter target = new ListsPresenter(view, model); 
            target.LoadLists();
            Assert.IsNotNull(view.Lists);
            Assert.IsTrue(view.Lists.Count() == 2);
        }
    }
}







































