﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Collections.Generic;
using Microsoft.Practices.SharePoint.Common.ServiceLocation;
using Microsoft.Practices.ServiceLocation;

namespace WebPartsInAction.Ch13.MVPWebPart.SiteListsWebPart {
    [ToolboxItemAttribute(false)]
    public class SiteListsWebPart : WebPart, IListsView {
        protected override void CreateChildControls() {
            IServiceLocator serviceLocator = SharePointServiceLocator.GetCurrent(SPContext.Current.Site);
            IListsService service = serviceLocator.GetInstance<IListsService>();
            
            ListsPresenter presenter = new ListsPresenter(this, service);
            presenter.LoadLists();

            foreach (ListInfo listInfo in this.Lists) {
                this.Controls.Add(new HyperLink() {
                    Text = listInfo.Title,
                    NavigateUrl = listInfo.Url
                });
                this.Controls.Add(new LiteralControl("<br/>"));
            }
        }

        public IEnumerable<ListInfo> Lists {
            get;
            set;
        }
    }
}
