﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using SPWPP=Microsoft.SharePoint.WebPartPages;
using System.Collections.ObjectModel;

namespace WebPartsInAction.Ch14.Connections.CustomFilter {
    [ToolboxItemAttribute(false)]
    public class CustomFilter : WebPart, SPWPP.ITransformableFilterValues {
        protected DropDownList _dropDown;
        protected override void CreateChildControls() {
            _dropDown = new DropDownList();
            _dropDown.Items.Add(new ListItem("Wictor Wilén", "http://feeds.feedburner.com/WictorWilen"));
            _dropDown.Items.Add(new ListItem("SharePoint Team Blog", "http://blogs.msdn.com/sharepoint/rss.xml"));
            _dropDown.AutoPostBack = true;
            this.Controls.Add(_dropDown);
        }

        public bool AllowAllValue {
            get { return true; }
        }

        public bool AllowEmptyValue {
            get { return false; }
        }

        public bool AllowMultipleValues {
            get { return false; }
        }

        public string ParameterName {
            get { return "Url"; }
        }

        public ReadOnlyCollection<string> ParameterValues {
            get {
                EnsureChildControls();
                string[] values = new string[] {_dropDown.SelectedValue};
                return new ReadOnlyCollection<string>(values);
            }
        }
        [ConnectionProvider("Feed filter", "ITransformableFilterValues", AllowsMultipleConnections = true)]
        public SPWPP.ITransformableFilterValues SetConnectionInterface() {
            return this;
        }
    }
}
