﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Web.UI.HtmlControls;

namespace WebPartsInAction.Ch14.Connections.FeedInputWebPart {
    [ToolboxItemAttribute(false)]
    public class FeedInputWebPart : WebPart, IUrlConnection {

        protected TextBox _url;
        protected Button _button;
        protected UpdatePanel updatePanel;

        protected override void CreateChildControls() {
            HtmlGenericControl fieldset = new HtmlGenericControl("fieldset");
            HtmlGenericControl legend = new HtmlGenericControl("legend") {
                InnerText = "Enter feed URL:"
            };
            fieldset.Controls.Add(legend);

            _url = new TextBox();
            fieldset.Controls.Add(_url);

            _button = new Button() {
                Text = "Submit",
                ID = "SubmitFeed"
            };

            fieldset.Controls.Add(_button);


            this.Controls.Add(fieldset);

            base.CreateChildControls();
        }

        public string Url {
            get {
                EnsureChildControls();
                return _url.Text;
            }
        }


        public Control AsyncTrigger {
            get {
                EnsureChildControls();
                return _button;
            }
        }


        [ConnectionProvider("Feed url")]
        public IUrlConnection SetFeedConnection() {
            return this;
        }
    }
}
