﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;

namespace WebPartsInAction.Ch4.ViewState.ViewStateWebPart {
    [ToolboxItemAttribute(false)]
    public class ViewStateWebPart : WebPart {
        public ViewStateWebPart() {
        }

        int counter = 0;

        protected override void CreateChildControls() {
            Button button = new Button() { Text = "Click me!" };
            button.Click += (s, e) => { counter++; };
            this.Controls.Add(button);
            base.CreateChildControls();
        }

        protected override void OnPreRender(EventArgs e) {
            this.Controls.Add(new LiteralControl("Count = " + counter.ToString()));
        }

        protected override void LoadViewState(object savedstate) {
            if (savedstate != null) {
                counter = (int)savedstate;
            }
        }
        protected override object SaveViewState() {
            return counter;
        }
    }
}
