﻿using System;
using System.Linq;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebPartPages;
using System.Web.UI;

namespace WebPartsInAction.Ch5.SiteGroupsFilter {
    public class SiteGroupsFilterControl: WebControl, IToolPaneControl, IPostBackDataHandler {
        public SiteGroupsFilterControl() {
            this.Text = string.Empty;
        }

        protected ListBox listBox;
        //static readonly string listId = ;

        protected override void CreateChildControls() {
            listBox = new ListBox();
            listBox.ID = "SiteGroupFilter";
            listBox.SelectionMode = ListSelectionMode.Multiple;

            SPContext context = SPContext.Current;

            var currentSelection = Text.Split(new char[] { ',' });
            
            foreach (SPGroup group in context.Site.RootWeb.SiteGroups) {
                listBox.Items.Add(
                    new ListItem() { 
                        Text= group.Name,
                        Selected = currentSelection.Any( g => g == group.Name )});
            }
            this.Controls.Add(listBox);
            base.CreateChildControls();
        }

        #region IToolPaneControl Members

        public string Text {
            get;
            set;
        }

        #endregion


        protected override void OnPreRender(EventArgs e) {
            base.OnPreRender(e);
            this.Page.RegisterRequiresPostBack(this);
        }



        #region IPostBackDataHandler Members

        public bool LoadPostData(string postDataKey, System.Collections.Specialized.NameValueCollection postCollection) {
            this.EnsureChildControls();
           
            var id = from key in postCollection.Keys.Cast<string>()
                     where key.EndsWith("$" + listBox.ID)
                     select key;
            if (id.First() != null) {
                this.Text = postCollection[id.First()];
                if (this.Text == null) {
                    this.Text = string.Empty;
                }
            }            
            return true;
        }

        public void RaisePostDataChangedEvent() {
        }

        #endregion
    }
}
