﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.WebPartPages;
using System.Collections;
using System.Globalization;
using Microsoft.SharePoint;

namespace WebPartsInAction.Ch5.SiteGroupsFilter {
    public class SiteGroupsRuntimeFilter : IRuntimeFilter2 {
        #region IRuntimeFilter2 Members

        public IToolPaneControl GetToolPaneControl() {
            return new SiteGroupsFilterControl() { ID = "SiteGroupsFilterControl" };
        }

        #endregion

        #region IRuntimeFilter Members

        public bool CheckRuntimeRender(string IsIncludedFilter) {
            SPContext context = SPContext.Current;
            
            if (string.IsNullOrEmpty(IsIncludedFilter)) {
                return true;
            }
            string[] filterArray = IsIncludedFilter.Split(new char[] { ',' });
            foreach (SPGroup group in context.Site.RootWeb.SiteGroups) {
                if (filterArray.Contains(group.Name) &&
                    group.ContainsCurrentUser) {
                    return true;
                }
            }
            return false;
        }

        public System.Collections.ArrayList InitializeStrings(System.Globalization.CultureInfo cultureInfo) {
            return new ArrayList(new string[] { "Target Groups" });
        }

        public bool IsFilterActive() {
            return true;
        }

        public string ValidateIsIncludedFilter(string persistedString) {
            return persistedString;
        }

        #endregion
    }
}
