﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint.Utilities;
using System.Globalization;
using System.ComponentModel;
using Microsoft.SharePoint.WebPartPages;

namespace WebPartsInAction.Ch6.Localization {
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = false, Inherited = true)]
    public class LocalizedWebCategoryAttribute: SPWebCategoryNameAttribute {

        private bool m_isLocalized;

        public LocalizedWebCategoryAttribute() {
        }

        public LocalizedWebCategoryAttribute(string categoryName)
            : this(categoryName, "core") {
        }
        public LocalizedWebCategoryAttribute(string categoryName, string resourceFile)
            : base(categoryName) {
            this.ResourceFile = resourceFile;
        }

        public string ResourceFile {
            get;
            set;
        }

        public override string CategoryName {
            get {
                if (!m_isLocalized) {
                    this.CategoryNameValue = SPUtility.GetLocalizedString("$Resources:" + base.CategoryName, this.ResourceFile, (uint)CultureInfo.CurrentUICulture.LCID);
                    m_isLocalized = true;
                }
                return base.CategoryName;
            }
        }
    }
}
