﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint.Utilities;
using System.Globalization;

namespace WebPartsInAction.Ch6.Localization {
[AttributeUsage(AttributeTargets.Property, AllowMultiple = false, Inherited = true)]
public class LocalizedWebDisplayNameAttribute : WebDisplayNameAttribute {

    private bool m_isLocalized;

    public LocalizedWebDisplayNameAttribute() {
    }

    public LocalizedWebDisplayNameAttribute(string displayName)
        : this(displayName, "core") {
    }
    public LocalizedWebDisplayNameAttribute(string displayName, string resourceFile)
        : base(displayName) {
        this.ResourceFile = resourceFile;
    }

    public string ResourceFile {
        get;
        set;
    }

    public override string DisplayName {
        get {
            if (!m_isLocalized) {
                this.DisplayNameValue = SPUtility.GetLocalizedString("$Resources:" + base.DisplayName, this.ResourceFile, (uint)CultureInfo.CurrentUICulture.LCID);
                m_isLocalized = true;
            }
            return base.DisplayName;
        }
    }
}
}
