﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.Utilities;
using WebPartsInAction.Ch6.Localization.Resources;
using System.Globalization;

namespace WebPartsInAction.Ch6.Localization.VisualWebPart1 {
    [ToolboxItemAttribute(false)]
    public class VisualWebPart1 : WebPart {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/WebPartsInAction.Ch6.Localization/VisualWebPart1/VisualWebPart1UserControl.ascx";

        protected override void CreateChildControls() {
            uint lang = (uint)CultureInfo.CurrentUICulture.LCID;

            Control control = Page.LoadControl(_ascxPath);
            Controls.Add(new Label {
                Text = SPUtility.GetLocalizedString("$Resources:Title","Resources",lang)
            });
            Controls.Add(new Label {
                Text = SPUtility.GetLocalizedString("$Resources:Title","GlobalResources",lang)
            });
            Controls.Add(new Label {
                Text = SPUtility.GetLocalizedString("$Resources:Title","RootResources",lang)
            });

            
            Controls.Add(new Label {
                Text = HttpContext.GetGlobalResourceObject("GlobalResources", "Title").ToString()
            });

            Controls.Add(new Label {
                Text = Properties.Resources.Title  
            });

            
            Controls.Add(control);
        }

[Personalizable]
[WebBrowsable(true)]
[LocalizedWebDisplayName("CustomProperty", "RootResources")]
[LocalizedWebDescription("CustomPropertyDesc", "RootResources")]
[LocalizedWebCategory("CustomCategory", "RootResources")]
public string CustomProperty {
    get;
    set;
}
    }
}
