﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Xml.Linq;
using Microsoft.SharePoint.Utilities;
using System.Linq;
using WebPartsInAction.Ch7.SandboxFeedProxy;

namespace WebPartsInAction.Ch7.SandboxFeed.SandboxedRSSWebPart {
    [ToolboxItemAttribute(false)]
    public class SandboxedRSSWebPart : WebPart {
        protected override void CreateChildControls() {
            string xml = SPUtility.ExecuteRegisteredProxyOperation(
                "WebPartsInAction.Ch7.SandboxFeedProxy, Version=1.0.0.0, Culture=utral, PublicKeyToken=2dc5b379e872af76",
                "WebPartsInAction.Ch7.SandboxFeedProxy.FeedOperation",
                new FeedOperationArgs("http://feeds2.feedburner.com/WictorWilen")                
                ).ToString();
            
            XElement feed = XElement.Parse(xml);
            var items = feed.Descendants("item");
            foreach (var item in items) {
                Panel panel = new Panel();
                panel.Controls.Add(new HyperLink() {
                    Text = "* " + item.Descendants("title").First().Value,
                    NavigateUrl = item.Descendants("link").First().Value
                });
                this.Controls.Add(panel);
            }
            this.ChildControlsCreated = true;
        }
    }
}
