using System;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Security;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint.UserCode;

namespace WebPartsInAction.Ch7.SandboxFeedProxy.Features.SandboxedFeedProxy {
    /// <summary>
    /// This class handles events raised during feature activation, deactivation, installation, uninstallation, and upgrade.
    /// </summary>
    /// <remarks>
    /// The GUID attached to this class may be used during packaging and should not be modified.
    /// </remarks>

    [Guid("cfdf22ed-8c1d-42b2-b033-75e3389600bf")]
    public class SandboxedFeedProxyEventReceiver : SPFeatureReceiver {
        // Uncomment the method below to handle the event raised after a feature has been activated.

public override void FeatureActivated(SPFeatureReceiverProperties properties) {
    Type type = typeof(FeedOperation);
    SPUserCodeService userCodeService = SPUserCodeService.Local;
    userCodeService.ProxyOperationTypes.Add(
        new SPProxyOperationType(type.Assembly.FullName, type.FullName));
    userCodeService.Update();
}


//Uncomment the method below to handle the event raised before a feature is deactivated.

public override void FeatureDeactivating(SPFeatureReceiverProperties properties) {
    Type type = typeof(FeedOperation);
    SPUserCodeService userCodeService = SPUserCodeService.Local;
    userCodeService.ProxyOperationTypes.Remove(
        new SPProxyOperationType(type.Assembly.FullName, type.FullName));
    userCodeService.Update();
}


        // Uncomment the method below to handle the event raised after a feature has been installed.

        //public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        //{
        //}


        // Uncomment the method below to handle the event raised before a feature is uninstalled.

        //public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        //{
        //}

        // Uncomment the method below to handle the event raised when a feature is upgrading.

        //public override void FeatureUpgrading(SPFeatureReceiverProperties properties, string upgradeActionName, System.Collections.Generic.IDictionary<string, string> parameters)
        //{
        //}
    }
}
