﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Utilities;
using System.Threading;

namespace WebPartsInAction.Ch8.MonitoredScopes.SlowWebPart {
    class CustomMonitor : ISPScopedPerformanceMonitor {
        static long s_counter = 0;

        public CustomMonitor() {
            Interlocked.Increment(ref s_counter);
        }

        public void Dispose() {
        }

        public string Description {
            get { return "Counts the calls"; }
        }

        public string Name {
            get { return "CallCounter"; }
        }

        public string RenderValueForWeb() {
            return string.Format("Called {0} times", s_counter);
        }

        public object Value {
            get {
                return Interlocked.Read(ref s_counter);
            }
        }

        public bool ValueIsExcessive {
            get {
                return Interlocked.Read(ref s_counter) > 5;
            }
        }
    }
}
