﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.Utilities;
using System.Collections.Generic;

namespace WebPartsInAction.Ch8.MonitoredScopes.SlowWebPart {
    [ToolboxItemAttribute(false)]
    public class SlowWebPart : WebPart {
        protected override void CreateChildControls() {
            using (SPMonitoredScope scope = new SPMonitoredScope("CreateChildControls")) {
               // SlowMethod();
                FastMethod();
                
            }
            Iterations();

            Critical();
        }
        private void SlowMethod() {
            using (SPMonitoredScope scope = new SPMonitoredScope("SlowMethod")) {
               // System.Threading.Thread.Sleep(1200);
            }
        }
        private void FastMethod() {
            using (SPMonitoredScope scope = new SPMonitoredScope("FastMethod")) {
                System.Threading.Thread.SpinWait(10);
            }
        }

        private void Iterations() {
            
            using (SPMonitoredScope scope = new SPMonitoredScope("Iterations", 100,new ISPScopedPerformanceMonitor[]{new CustomMonitor()})) {
                for (int i = 0; i < 6; i++) {
                    Iteration();
                }
            }
           
        }

        private void Iteration() {
            using (SPMonitoredScope scope = new SPMonitoredScope("Iteration")) {
                System.Threading.Thread.Sleep(100);
            }
        }

        private void Critical() {

            using (SPMonitoredScope scope = new SPMonitoredScope("Critical")) {
                SPCriticalTraceCounter.AddDataToScope(2010, "Critical Error", 15, "An error occurred");
                
            }
        }
    }
}
