﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Xml.Linq;

namespace WebPartsInAction.Ch9.AsyncRSSWebPart.AsyncRSSFeedWebPart {
    class RSSFeedAsyncTask{
        delegate void AsyncTaskDelegate();
        private AsyncTaskDelegate _asyncTaskDelegate;

        public delegate void AsyncTaskEnded();
        private AsyncTaskEnded _asyncTaskEnded; 
        private string _url;

        public RSSFeedAsyncTask(string url) {
            _url = url;
        }
        public RSSFeedAsyncTask(string url, AsyncTaskEnded taskEnded) {
            _url = url;
            _asyncTaskEnded = taskEnded;
        }

        
        public IAsyncResult OnBegin(object sender, EventArgs e, AsyncCallback callback, object data) {
            _asyncTaskDelegate = new AsyncTaskDelegate(Execute);
            IAsyncResult result = _asyncTaskDelegate.BeginInvoke(callback, data);
            return result;
        }
        public void OnEnd(IAsyncResult result) {
            if (_asyncTaskEnded != null) {
                _asyncTaskEnded.Invoke();
            }
            _asyncTaskDelegate.EndInvoke(result);
        }
        public void OnTimeout(IAsyncResult result) {
            FeedData = new XElement("Timeout");
        }

        public void Execute() {
            FeedData = XElement.Load(_url);
            System.Threading.Thread.Sleep(5000);
        }

        public XElement FeedData {
            get;
            protected set;
        }

    }
}
